Parma_Polyhedra_Library::Concrete_Expression_Type Class Reference

The type of a concrete expression. More...

`#include <ppl.hh>`

## Public Member Functions

bool | is_bounded_integer () const
| Returns `true` if and only if `*this` is a bounded integer type.
bool | is_floating_point () const
| Returns `true` if and only if `*this` is a floating point type.
Bounded_Integer_Type_Width | bounded_integer_type_width () const
| Returns the width in bits of the bounded integer type encoded by `*this`. More...
Bounded_Integer_Type_Representation | bounded_integer_type_representation () const
| Returns the representation of the bounded integer type encoded by `*this`. More...
Bounded_Integer_Type_Overflow | bounded_integer_type_overflow () const
| Returns the overflow behavior of the bounded integer type encoded by `*this`. More...
Floating_Point_Format | floating_point_format () const
| Returns the format of the floating point type encoded by `*this`. More...
bool | OK () const
| Checks if all the invariants are satisfied.

## Static Public Member Functions

static Concrete_Expression_Type | bounded_integer (Bounded_Integer_Type_Width width, Bounded_Integer_Type_Representation representation, Bounded_Integer_Type_Overflow overflow)
| Returns the bounded integer type corresponding to `width`, `representation` and `overflow`.
static Concrete_Expression_Type | floating_point (Floating_Point_Format format)
| Returns the floating point type corresponding to `format`.

## Detailed Description

The type of a concrete expression.

## Member Function Documentation

Bounded_Integer_Type_Width Parma_Polyhedra_Library::Concrete_Expression_Type::bounded_integer_type_width | ( | ) |  | const

inline

Returns the width in bits of the bounded integer type encoded by `*this`.

The behavior is undefined if `*this` does not encode a bounded integer type.

Bounded_Integer_Type_Representation Parma_Polyhedra_Library::Concrete_Expression_Type::bounded_integer_type_representation | ( | ) |  | const

inline

Returns the representation of the bounded integer type encoded by `*this`.

The behavior is undefined if `*this` does not encode a bounded integer type.

Bounded_Integer_Type_Overflow Parma_Polyhedra_Library::Concrete_Expression_Type::bounded_integer_type_overflow | ( | ) |  | const

inline

Returns the overflow behavior of the bounded integer type encoded by `*this`.

The behavior is undefined if `*this` does not encode a bounded integer type.

Floating_Point_Format Parma_Polyhedra_Library::Concrete_Expression_Type::floating_point_format | ( | ) |  | const

inline

Returns the format of the floating point type encoded by `*this`.

The behavior is undefined if `*this` does not encode a floating point type.

The documentation for this class was generated from the following file:

- ppl.hh